--- /etc/sysconfig/pure-ftpd.original	1970-01-01 01:00:00.000000000 +0100
+++ /etc/sysconfig/pure-ftpd	2008-02-13 15:00:43.000000000 +0100
@@ -0,0 +1,5 @@
+# Set this to "yes" if you want to run a script when an upload completes.
+PURE_UPLOADSCRIPT_ENABLE="yes"
+
+# Path to the uploadscript to be executed after an upload has finished.
+PURE_UPLOADSCRIPT_PATH="/etc/pure-ftpd/pure-uploadscript.sh"
--- /etc/init.d/pure-ftpd.original	2008-02-13 13:48:00.000000000 +0100
+++ /etc/init.d/pure-ftpd	2008-02-13 14:02:58.000000000 +0100
@@ -20,8 +20,14 @@
 # Description:    Start pure-ftpd ftp server.
 ### END INIT INFO
 
+test -f /etc/sysconfig/pure-ftpd && . /etc/sysconfig/pure-ftpd
+
 FTPD_BIN=/usr/sbin/pure-ftpd
+UPSCRIPT_BIN=/usr/sbin/pure-uploadscript
+
 test -x $FTPD_BIN || exit 5
+test "${PURE_UPLOADSCRIPT_ENABLE}" = "yes" && test -x $UPSCRIPT_BIN || exit 5
+test "${PURE_UPLOADSCRIPT_ENABLE}" = "yes" && test -x $PURE_UPLOADSCRIPT_PATH || exit 5
 
 # Shell functions sourced from /etc/rc.status:
 #      rc_check         check and set local and overall rc status
@@ -56,11 +62,14 @@
     start)
 	echo -n "Starting pure-ftpd"
         FTPD_ARGS=`/usr/sbin/pure-config-args /etc/pure-ftpd/pure-ftpd.conf`
+	test "${PURE_UPLOADSCRIPT_ENABLE}" = "yes" && FTPD_ARGS="$FTPD_ARGS -o" && \
+	startproc $UPSCRIPT_BIN -r $PURE_UPLOADSCRIPT_PATH
 	startproc $FTPD_BIN $FTPD_ARGS
 	rc_status -v
 	;;
     stop)
 	echo -n "Shutting down pure-ftpd"
+	test "${PURE_UPLOADSCRIPT_ENABLE}" = "yes" && killproc -TERM $UPSCRIPT_BIN
 	killproc -TERM $FTPD_BIN
 	rc_status -v
 	;;
